
#Clase Dieta padre que representa un menu con su titulo, platos y datos correspondientes a los nutrientes.
class Dieta
  include Comparable
  #Titulo de la dieta.
  attr_accessor :titulo
  #Porcentaje de injesta diaria.
  attr_accessor :ing_diaria
  #Platos que contiene la dieta.
  attr_accessor :platos
  #Calorias de la dieta.
  attr_accessor :vct
  #Porcentaje de calorias.
  attr_accessor :prot
  #Porcentaje de grasas.
  attr_accessor :grasas
  #Porcentaje de carbohidratos. 
  attr_accessor :carbo
  #Metodo que inicializa los objetos.
  def initialize(titulo, ing_diaria, platos, vct, prot, grasas, carbo)
    @titulo = titulo
    @ing_diaria = ing_diaria
    @platos = platos
    @vct = vct
    @prot = prot
    @grasas = grasas
    @carbo = carbo
  end
  
  #Metodo que formatea la salida de una Dieta.
  def to_s
    title = "#{@titulo} (#{@ing_diaria})\n"
    for i in 0..@platos.size-1
      title+="-#{@platos[i][0]}, #{@platos[i][1]}, #{@platos[i][2]}\n"
    end
    title += "V.C.T. | %\t#{@vct} | #{@prot} - #{@grasas} - #{@carbo}"
  end

  #Metodo necesario para el uso del modulo Comparable.
  def <=> (an0ther)
    self.vct <=> an0ther.vct
  end
end

#Clase Menu_alimentos que hereda de la clase padre Dieta.
class Menu_alimentos < Dieta
  #Atributo para el grupo de alimentos.
  attr_accessor :alimentos

  #Metodo que inicia los objetos.
  def initialize(alimentos, dieta)
    @alimentos = alimentos    
    super(dieta.titulo, dieta.ing_diaria, dieta.platos, dieta.vct, dieta.prot, dieta.grasas, dieta.carbo)
  end

  #Metodo que formatea la salida de una dieta con grupo de alimentos.
  def to_s
    string = super.to_s + "\nGrupo de alimentos: #{alimentos}\n"
  end

end

#Clase Menu_edad que hereda de la clase padre Dieta.
class Menu_edad < Dieta
  #Atributo para el rango de edades de los alimentos.
  attr_accessor :edad

  #Metodo que inicia los objetos.
  def initialize(edad, dieta)
    @edad = edad
    super(dieta.titulo, dieta.ing_diaria, dieta.platos, dieta.vct, dieta.prot, dieta.grasas, dieta.carbo)  
  end

  #Metodo que formatea la salida de una dieta con rango de edades.
  def to_s
    string = super.to_s + "\nEdad: #{@edad}\n"
  end

end
