#Estructura del nodo que contiene el valor, el nodo siguiente, y el nodo anterior.
Node = Struct.new(:value, :next, :prev)

#Clase lista doblemente enlazada.
class Lista
  include Enumerable
  #Nodo del principio de la lista.
  attr_accessor :head
  #Nodo del final de la lista.
  attr_accessor :tail

  #Metodo que inicializa los objetos de tipo Lista.
  def initialize
    @head = @tail = nil
  end

  #Metodo que devuelve true si la lista esta vacia.
  def is_empty

    if @head==nil && @tail==nil
      return true
    else
      return false
    end

  end
  
  #Metodo que mete un elemento en la lista por el final.
  def push(v)

    nodo = Node.new(v,nil,nil)
            
    if (@head == nil)
      @head = nodo
    else
      @tail.next = nodo
      nodo.prev = @tail
    end
    @tail=nodo

  end

  #Metodo que mete un elemento en la lista por el principio.
  def push_head(v)

    nodo = Node.new(v,nil,nil)
    nodo.next = @head
    nodo.prev=nil
    if @tail==nil
      @final=nodo
    else
      @head.prev=nodo
    end
    
    @head = nodo
  end  
    
  #Metodo que saca un elemento de la lista por el principio.
  def pop
   
    if(!is_empty())
      nodo = @head
      @head = @head.next
      return nodo.value
    else
      return nil
    end

  end

  #Metodo que saca un elemento de la lista por el final.
  def pop_tail
    if(@tail==nil)
      return false
    else
      nodo = @tail
      @tail = @tail.prev
    end
    return nodo.value
  end

  #Metodo que formatea la salida de la lista.
  def to_s
    aux=@head
    i=1
    str=""
    while(aux!=nil)
      str+="#{i}) #{aux[:value]}\n"
      aux=aux[:next]
      i+=1
    end
    str
  end

  #Metodo necesario para el uso del modulo Enumerable.
  def each
    aux=@head
    while(aux!=nil)
      yield aux[:value]
      aux=aux[:next]
    end
  end 
  
end

