class Menu_dsl
  include Comparable
  #Titulo de la dieta.
  attr_accessor :titulo
  #Porcentaje de injesta diaria.
  attr_accessor :ing_diaria
  #Platos que contiene la dieta.
  attr_accessor :platos
  #Calorias de la dieta.
  attr_accessor :porcentajes

  def initialize(name, &block)
    @titulo = name
    @ing_diaria = []
    @porcentajes = []
    @platos = []

    if block_given?  
      if block.arity == 1
        yield self
      else
       instance_eval(&block) 
      end
    end
  end
   

def to_s
    output = @titulo
    output << "\n#{'=' * @titulo.size}\n"
    output << "\nMin: #{@ing_diaria[0]}\n"
    output << "Max: #{@ing_diaria[1]}\n\n"

    @platos.each_with_index do |plato, index|
      output << "#{index + 1}) #{plato[0]}. Porción: #{plato[1]}. Cantidad: #{plato[2]}\n"
    end
    
    output << "V.C.T. | %\t#{@porcentajes[0]} kcal | #{@porcentajes[1]}% - #{@porcentajes[2]}% - #{@porcentajes[3]}%\n\n"
    output
  end

  def ingesta(ing = {})
    i = []
    i << "#{ing[:min]}" if ing[:min]
    i << "#{ing[:max]}" if ing[:max]
    @ing_diaria = i
  end

  def porcent(porc = {})
    p = []
    p << "#{porc[:vct]}" if porc[:vct]
    p << "#{porc[:proteinas]}" if porc[:proteinas]
    p << "#{porc[:grasas]}" if porc[:grasas]
    p << "#{porc[:hidratos]}" if porc[:hidratos] 

   @porcentajes = p
  end

  def plat(options = {})
    pl = []
    pl << "#{options[:descripcion]}" if options[:descripcion]
    pl << "#{options[:porcion]}" if options[:porcion]
    pl << "#{options[:gramos]}" if options[:gramos]

    @platos << pl 
  end

  def <=>(an0ther)
    self.porcentajes[0] <=> an0ther.porcentajes[0]
  end
end

 
